
#include "fpt_mpis.h"
#include "fpt_isvm.h"
#include "isvm.h"

extern int *cost;
extern float *alpha;

extern float *incProfit;

extern int updateState;
extern int justItemAdd;
extern int justItemAdd2;

extern int *finalOutput;
extern int noOfFinalOutput;

// 2 : all selected
// 1 : some selected and some unselected
// 0 : all unselected
int vm_isContainCase(transPtr transaction, int *isChoose)
{
	int returnValue = 0;

	int i;

	int isAll;
	int sum;
	int itemNo;

	sum = 0;
	for (i = 0; i < transaction->noOfItem; i++)
	{
		itemNo = transaction->item[i];
		sum += isChoose[itemNo];
	}

	if (sum == 0)
	{
		// all unselected
		return 0;
	}
	else if (sum == transaction->noOfItem)
	{
		// all selected
		return 2;
	}
	else
	{
		// some selected and some unselected
		return 1;
	}

}

// 3 : this transactions contains the items just added
// 2 : all selected
// 1 : some selected and some unselected
// 0 : all unselected
int vm_isContainCase_Update(transPtr transaction, int *isChoose)
{
	int returnValue = 0;

	int i;

	int isAll;
	int sum;
	int itemNo;

	sum = 0;
	for (i = 0; i < transaction->noOfItem; i++)
	{
		itemNo = transaction->item[i];
		if (itemNo == justItemAdd)
		{
			return 3;
		}
		sum += isChoose[itemNo];
	}

	if (sum == 0)
	{
		// all unselected
		return 0;
	}
	else if (sum == transaction->noOfItem)
	{
		// all selected
		return 2;
	}
	else
	{
		// some selected and some unselected
		return 1;
	}

}



// 3 : this transactions contains some marketing items
// 2 : all selected
// 1 : some selected and some unselected
// 0 : all unselected
int vm_isContainCase_Update2(transPtr transaction, int *isChoose)
{
	int returnValue = 0;

	int i;

	int isAll;
	int sum;
	int itemNo;

	isChoose[justItemAdd] = 0;
	sum = 0;
	for (i = 0; i < transaction->noOfItem; i++)
	{
		itemNo = transaction->item[i];
		//if (itemNo == justItemAdd2)
		//{
		//	return 3;
		//}
		sum += isChoose[itemNo];
	}
	isChoose[justItemAdd] = 1;

	if (sum != 0)
	{
		return 3;
	}

	if (sum == 0)
	{
		// all unselected
		return 0;
	}
	else if (sum == transaction->noOfItem)
	{
		// all selected
		return 2;
	}
	else
	{
		// some selected and some unselected
		return 1;
	}

}

void fp_vm_doTransaction(double *returnValue, transPtr transaction, int *freqItemP, int *indexList, FPTreeNode node, FPTreeNode *headerTableLink, short *fpMap, int *isChoose, int *profit, int noOfContain)
{
	int sel[100];// = (int *) malloc(sizeof(int)*100);

	int flag;
	
	int j;
	double temp;
	
	int path;
	int itemNo;

	float aValue;

	int count;

	int den = 0;
	int num = 0;

	//int *sel;
	int noOfSel;

	nodePtr list;

	if (updateState == 1)
	{
		flag = vm_isContainCase_Update(transaction, isChoose);
		
		if (flag == 3)
		{
			// transaction containing marketing items just added
			flag = vm_isContainCase_Update2(transaction, isChoose);

			if (flag != 3)
			{
				// transaction containing marketing items just added and all non-marketing items

				// justItemAdd
				flag = vm_isContainCase(transaction, isChoose);
				
				if (flag == 0)
				{
					// all unselected items
					
					// do nothing
				}
				else if (flag == 2)
				{
					// all selected items
					/*		
					temp = 0;
					for (j = 0; j < transaction->noOfItem; j++)
					{
					itemNo = transaction->item[j];
					//aValue = alpha[itemNo];
					
					  //temp += profit[itemNo]*aValue - (1+aValue)*cost[itemNo];
					  temp += incProfit[itemNo];
					  }
					  if (noOfContain > 1)
					  {
					  temp *= noOfContain;
					  }
					  
						(*returnValue) += temp;
					*/
				}
				else
				{
					// flag == 1
					// some selected and some unselected
					
					// find sel 
					
					noOfSel = 0;
					//sel = (int *) malloc(sizeof(int)*maxTransSize);
					for (j = 0; j < transaction->noOfItem; j++)
					{
						itemNo = transaction->item[j];
						if (isChoose[itemNo] == 1)
						{
							sel[noOfSel] = itemNo;
							noOfSel++;

							// newly add
							aValue = alpha[itemNo];
							(*returnValue) += (profit[itemNo]*aValue - (1+aValue)*cost[itemNo])*noOfContain;
						}
					}
					
					// find the denumerator
					list = vm_getDen(dataVert, sel, noOfSel, itemNo, &den);
#ifdef ARRAY
					if (den == 0)
#else
						if (list == NULL)
#endif
						{
							temp = 0;
						}
						else
						{
							temp = 0;
							for (j = 0; j < transaction->noOfItem; j++)
							{
								itemNo = transaction->item[j];
								
								
								if (isChoose[itemNo] == 1)
								{
									//temp += (profit[itemNo]*aValue - (1+aValue)*cost[itemNo])*noOfContain;
									//temp += incProfit[itemNo];
								}
								else
								{
									aValue = alpha[itemNo];
									
									vm_getNum(dataVert, sel, noOfSel, itemNo, list, den, &num);
									
									if (num != 0)
									{
										// assume aValue is the same
										temp += aValue*num*profit[itemNo]/(double)den;
										//temp += 0;
									}
								}
							}
							if (noOfContain > 1)
							{
								temp *= noOfContain;
							}
							
							//freeList(list);
						}
						//free(sel);
						
						if (temp != 0)
						{
							(*returnValue) += temp;
						}	
						
				}
							


			}
			else if (flag == 3)
			{
				// transaction containing marketing items just added and some marketing items

				// justItemAdd
				isChoose[justItemAdd] = 0;
				flag = vm_isContainCase(transaction, isChoose);
				
				if (flag == 0)
				{
					// all unselected items
					
					// do nothing
				}
				else if (flag == 2)
				{
					// all selected items
							
					temp = 0;
					for (j = 0; j < transaction->noOfItem; j++)
					{
					itemNo = transaction->item[j];
					
					  aValue = alpha[itemNo];
					
					  temp += (profit[itemNo]*aValue - (1+aValue)*cost[itemNo])*noOfContain;
					  //temp += incProfit[itemNo];
					  }
					  if (noOfContain > 1)
					  {
					  temp *= noOfContain;
					  }
					  
						(*returnValue) -= temp;
					
				}
				else
				{
					// flag == 1
					// some selected and some unselected
					
					// find sel 
					
					noOfSel = 0;
					//sel = (int *) malloc(sizeof(int)*maxTransSize);
					for (j = 0; j < transaction->noOfItem; j++)
					{
						itemNo = transaction->item[j];
						if (isChoose[itemNo] == 1)
						{
							sel[noOfSel] = itemNo;
							noOfSel++;

							// newly add
							aValue = alpha[itemNo];
							(*returnValue) -= (profit[itemNo]*aValue - (1+aValue)*cost[itemNo])*noOfContain;
						}
					}
					
					// find the denumerator
					list = vm_getDen(dataVert, sel, noOfSel, itemNo, &den);
#ifdef ARRAY
					if (den == 0)
#else
						if (list == NULL)
#endif
						{
							temp = 0;
						}
						else
						{
							temp = 0;
							for (j = 0; j < transaction->noOfItem; j++)
							{
								itemNo = transaction->item[j];
								
								
								if (isChoose[itemNo] == 1)
								{
									//temp += profit[itemNo]*aValue - (1+aValue)*cost[itemNo];
									//temp += incProfit[itemNo];
								}
								else
								{
									aValue = alpha[itemNo];
									
									vm_getNum(dataVert, sel, noOfSel, itemNo, list, den, &num);
									
									if (num != 0)
									{
										// assume aValue is the same
										temp += aValue*num*profit[itemNo]/(double)den;
										//temp += 0;
									}
								}
							}
							if (noOfContain > 1)
							{
								temp *= noOfContain;
							}
							
							//freeList(list);
						}
						//free(sel);
						
						if (temp != 0)
						{
							(*returnValue) -= temp;
						}	
						
				}
				
				isChoose[justItemAdd] = 1;
				
				
				// newly added
				//itemNo = justItemAdd;
				//(*returnValue) += (profit[itemNo]*aValue - (1+aValue)*cost[itemNo])*noOfContain;
				
				
				// justItemAdd
				flag = vm_isContainCase(transaction, isChoose);
				
				if (flag == 0)
				{
					// all unselected items
					
					// do nothing
				}
				else if (flag == 2)
				{
					// all selected items
							
					temp = 0;
					for (j = 0; j < transaction->noOfItem; j++)
					{
						itemNo = transaction->item[j];
						aValue = alpha[itemNo];
					
						temp += (profit[itemNo]*aValue - (1+aValue)*cost[itemNo]);
						//temp += incProfit[itemNo];
					}
					if (noOfContain > 1)
					{
						temp *= noOfContain;
					}
					  
					(*returnValue) += temp;
					
				}
				else
				{
					// flag == 1
					// some selected and some unselected
					
					// find sel 
					
					noOfSel = 0;
					//sel = (int *) malloc(sizeof(int)*maxTransSize);
					for (j = 0; j < transaction->noOfItem; j++)
					{
						itemNo = transaction->item[j];
						if (isChoose[itemNo] == 1)
						{
							sel[noOfSel] = itemNo;
							noOfSel++;

							// newly add
							aValue = alpha[itemNo];
							(*returnValue) += (profit[itemNo]*aValue - (1+aValue)*cost[itemNo])*noOfContain;
						}

						
					}
					
					// find the denumerator
					list = vm_getDen(dataVert, sel, noOfSel, itemNo, &den);
#ifdef ARRAY
					if (den == 0)
#else
						if (list == NULL)
#endif
						{
							temp = 0;
						}
						else
						{
							temp = 0;
							for (j = 0; j < transaction->noOfItem; j++)
							{
								itemNo = transaction->item[j];
								
								
								if (isChoose[itemNo] == 1)
								{
									//temp += profit[itemNo]*aValue - (1+aValue)*cost[itemNo];
									//temp += incProfit[itemNo];
								}
								else
								{
									aValue = alpha[itemNo];
									
									vm_getNum(dataVert, sel, noOfSel, itemNo, list, den, &num);
									
									if (num != 0)
									{
										// assume aValue is the same
										temp += aValue*num*profit[itemNo]/(double)den;
										//temp += 0;
									}
								}
							}
							if (noOfContain > 1)
							{
								temp *= noOfContain;
							}
							
							//freeList(list);
						}
						//free(sel);
						
						if (temp != 0)
						{
							(*returnValue) += temp;
						}	
						
				}
			}
		}
	}
	else
	{
		
		//flag = isContainCase(transaction, isChoose);
		flag = vm_isContainCase(transaction, isChoose);
		
		if (flag == 0)
		{
			// all unselected items
			
			// do nothing
		}
		else if (flag == 2)
		{
			// all selected items
			/*		
			temp = 0;
			for (j = 0; j < transaction->noOfItem; j++)
			{
			itemNo = transaction->item[j];
			//aValue = alpha[itemNo];
			
			  //temp += profit[itemNo]*aValue - (1+aValue)*cost[itemNo];
			  temp += incProfit[itemNo];
			  }
			  if (noOfContain > 1)
			  {
			  temp *= noOfContain;
			  }
			  
				(*returnValue) += temp;
			*/
		}
		else
		{
			// flag == 1
			// some selected and some unselected
			
			// find sel 
			
			noOfSel = 0;
			//sel = (int *) malloc(sizeof(int)*maxTransSize);
			for (j = 0; j < transaction->noOfItem; j++)
			{
				itemNo = transaction->item[j];
				if (isChoose[itemNo] == 1)
				{
					sel[noOfSel] = itemNo;
					noOfSel++;
				}
			}
			
			// find the denumerator
			list = vm_getDen(dataVert, sel, noOfSel, itemNo, &den);
#ifdef ARRAY
			if (den == 0)
#else
				if (list == NULL)
#endif
				{
					temp = 0;
				}
				else
				{
					temp = 0;
					for (j = 0; j < transaction->noOfItem; j++)
					{
						itemNo = transaction->item[j];
						
						
						if (isChoose[itemNo] == 1)
						{
							//temp += profit[itemNo]*aValue - (1+aValue)*cost[itemNo];
							//temp += incProfit[itemNo];
						}
						else
						{
							aValue = alpha[itemNo];
							
							vm_getNum(dataVert, sel, noOfSel, itemNo, list, den, &num);
							
							if (num != 0)
							{
								// assume aValue is the same
								temp += aValue*num*profit[itemNo]/(double)den;
								//temp += 0;
							}
						}
					}
					if (noOfContain > 1)
					{
						temp *= noOfContain;
					}
					
					//freeList(list);
				}
				//free(sel);
				
				if (temp != 0)
				{
					(*returnValue) += temp;
				}
				
				
		}
	}
}


// for normal
void vm_doCreateFP(double *returnValue, int *freqItemP, int *indexList, FPTreeNode node, short *fpMap, int *isChoose, int *profit)
{
	transPtr transaction;

	int noOfContain;
	int count;

	FPTreeNode parent;



	// check whether the node's count is zero
	if (node->numPath == 0)
	{
		return;
	}
	else
	{
		// create trans
		transaction = (transPtr) malloc(sizeof(trans));
		transaction->item = (int *) malloc(sizeof(int)*noOfItem);
		
		noOfContain = node->numPath;
		
		count = 0;
		node->numPath -= noOfContain;
		transaction->item[count] = node->item;
		count++;
		
		parent = node->parent;
		
		
		while ((parent != NULL) && (parent->parent != NULL))
		{
			parent->numPath -= noOfContain;
			transaction->item[count] = parent->item;
			count++;
			
			parent = parent->parent;
		}
		
		transaction->noOfItem = count;
		
		// just create a transaction
		

		fp_vm_doTransaction(returnValue, transaction, freqItemP, indexList, rootSet, headerTableLinkSet, fpMap, isChoose, profit, noOfContain);
		
		
		
		free(transaction->item);
		free(transaction);
	}
}


// for H
void vm_doCreateFP2(double *returnValue, double *returnValue2, int *freqItemP, int *indexList, FPTreeNode node, short *fpMap, int *isChoose, int *profit, double *revNo, int itemSpecial)
{
	transPtr transaction;

	int noOfContain;
	int count;

	FPTreeNode parent;

	int flag;

	int j;
	double temp;

	int path;
	int itemNo;

	int isExist;

	// check whether the node's count is zero
	if (node->numPath == 0)
	{
		return;
	}
	else
	{
		// create trans
		transaction = (transPtr) malloc(sizeof(trans));
		transaction->item = (int *) malloc(sizeof(int)*noOfItem);
		
		noOfContain = node->numPath;
		
		count = 0;
		node->numPath -= noOfContain;
		transaction->item[count] = node->item;
		count++;
		
		parent = node->parent;
		
		
		while ((parent != NULL) && (parent->parent != NULL))
		{
			parent->numPath -= noOfContain;
			transaction->item[count] = parent->item;
			count++;
			
			parent = parent->parent;
		}
		
		transaction->noOfItem = count;
		
		// just create a transaction
		
		flag = vm_isContainCase(transaction, isChoose);
		
		if (flag == 0)
		{
			// all unselected items
			
			// do nothing
		}
		else
		{
			// check whether the trans contain specialItem
			isExist = 0;
			for (j = 0; j < transaction->noOfItem; j++)
			{
				if (transaction->item[j] == itemSpecial)
				{
					isExist = 1;
					break;
				}
			}

			if (flag == 2)
			{
				// all selected items
				
				temp = 0;
				for (j = 0; j < transaction->noOfItem; j++)
				{
					itemNo = transaction->item[j];
					
					temp += profit[itemNo];
				}
				temp *= noOfContain;
				
				(*returnValue) += temp;

				if (isExist == 0)
				{
					(*returnValue2) += temp;
				}
				else
				{
					(*returnValue2) += temp;

					for (j = 0; j < transaction->noOfItem; j++)
					{
						itemNo = transaction->item[j];
						if (itemNo == itemSpecial)
						{
							(*returnValue2) -= profit[itemSpecial];
						}
						else
						{
							(*returnValue2) -= profit[itemNo]*getMatrix(itemSpecial, itemNo)*revNo[itemNo];
						}
					}
				}
			}
			else
			{
				// flag == 1
				// some selected and some unselected
				
				count = 0;
				path = 0;
				
				for (j = 0; j < transaction->noOfItem; j++)
				{
					itemNo = transaction->item[j];
					
					freqItemP[count] = itemNo;
					indexList[count] = (int)fpMap[itemNo];
					count++;
				}
				
				q_sortA(indexList, freqItemP, 0, count-1, count);
				
				insert_tree(freqItemP, indexList, noOfContain, 0, count, rootSet, headerTableLinkSet, &path);
			}
		}
		
		free(transaction->item);
		free(transaction);
	}
}

// for update
void vm_doCreateFP_diff(double *returnValue, double *returnValue2, int *freqItemP, int *indexList, FPTreeNode node, short *fpMap, short *fpMap2, int *isChoose, int *profit, int itemAdd, int itemRemove)
{
	transPtr transaction;

	int noOfContain;

	int isContain;

	int *isChoose2;

	int count;

	FPTreeNode parent;



	// check whether the node's count is zero
	if (node->numPath == 0)
	{
		return;
	}
	else
	{
		isChoose2 = (int *) malloc(sizeof(int)*noOfItem);
		memcpy(isChoose2, isChoose, sizeof(int)*noOfItem);

		// create trans
		transaction = (transPtr) malloc(sizeof(trans));
		transaction->item = (int *) malloc(sizeof(int)*noOfItem);
		
		noOfContain = node->numPath;
		
		count = 0;
		node->numPath -= noOfContain;
		transaction->item[count] = node->item;
		count++;
		
		parent = node->parent;
		
		
		while ((parent != NULL) && (parent->parent != NULL))
		{
			parent->numPath -= noOfContain;
			transaction->item[count] = parent->item;
			count++;
			
			parent = parent->parent;
		}
		
		transaction->noOfItem = count;
		
		// just create a transaction

		// check whether contains itemAdd or itemRemove
		isContain = isContainAddRemove(transaction, itemAdd, itemRemove);
		if (isContain == 1)
		{
			
			// ***** For S U itemAdd
			isChoose2[itemAdd] = 1;
			isChoose2[itemRemove] = 0;

			// do transaction
			fp_doTransaction(returnValue, transaction, freqItemP, indexList, rootSet, headerTableLinkSet, fpMap, isChoose2, profit, noOfContain);


			// ***** For S U itemRemove
			isChoose2[itemAdd] = 0;
			isChoose2[itemRemove] = 1;

			// do transaction
			fp_doTransaction(returnValue2, transaction, freqItemP, indexList, rootSet2, headerTableLinkSet2, fpMap2, isChoose2, profit, noOfContain);
		}
		
		free(transaction->item);
		free(transaction);
		free(isChoose2);
	}
}

// for normal
void fp_vm_scanTrans(double *returnValue, int *freqItemP, int *indexList, FPTreeNode node, transPtr *data, short *fpMap, int *isChoose, int *profit)
{
	
	//int itemNo;

	childLink nextChild;
	
	if (node == NULL)
	{
		return;
	}


	if (node->children == NULL)
	{
		// this node has no children
		// (i.e. this node is leaf)
		
		
		//doCreateFP(double *returnValue, int *freqItemP, int *indexList, FPTreeNode node, short *fpMap, int *isChoose, int *profit)
		vm_doCreateFP(returnValue, freqItemP, indexList, node, fpMap, isChoose, profit);
	}
	else
	{
		// this node has children
		// (need to explore the children first
		//  by using depth-first search)

		// explore children
		nextChild = node->children;
		while (nextChild != NULL)
		{
			//fp_scanTrans(double *returnValue, int *freqItemP, int *indexList, FPTreeNode node, transPtr *data, short *fpMap, int *isChoose, int *profit)
			fp_vm_scanTrans(returnValue, freqItemP, indexList, nextChild->node, data, fpMap, isChoose, profit);
			
			nextChild = nextChild->next;
		}

		if (node->parent == NULL)
		{
			// root
			return;
		}
		else
		{
			vm_doCreateFP(returnValue, freqItemP, indexList, node, fpMap, isChoose, profit);
		}
	}

}

//fp_scanTrans2(&returnValue, &returnValue2, freqItemP, indexList, root, data, fpMap, isChoose, profit);
// for H
void fp_vm_scanTrans2(double *returnValue, double *returnValue2, int *freqItemP, int *indexList, FPTreeNode node, transPtr *data, short *fpMap, int *isChoose, int *profit, double *revNo, int itemSpecial)
{
	
	//int itemNo;

	childLink nextChild;
	
	if (node == NULL)
	{
		return;
	}


	if (node->children == NULL)
	{
		// this node has no children
		// (i.e. this node is leaf)
		
		
		//doCreateFP(double *returnValue, int *freqItemP, int *indexList, FPTreeNode node, short *fpMap, int *isChoose, int *profit)
		doCreateFP2(returnValue, returnValue2, freqItemP, indexList, node, fpMap, isChoose, profit, revNo, itemSpecial);
	}
	else
	{
		// this node has children
		// (need to explore the children first
		//  by using depth-first search)

		// explore children
		nextChild = node->children;
		while (nextChild != NULL)
		{
			//fp_scanTrans(double *returnValue, int *freqItemP, int *indexList, FPTreeNode node, transPtr *data, short *fpMap, int *isChoose, int *profit)
			fp_scanTrans2(returnValue, returnValue2, freqItemP, indexList, nextChild->node, data, fpMap, isChoose, profit, revNo, itemSpecial);
			
			nextChild = nextChild->next;
		}

		if (node->parent == NULL)
		{
			// root
			return;
		}
		else
		{
			doCreateFP2(returnValue, returnValue2, freqItemP, indexList, node, fpMap, isChoose, profit, revNo, itemSpecial);
		}
	}

}

// for diff

void fp_vm_scanTrans_diff(double *returnValue, double *returnValue2, int *freqItemP, int *indexList, FPTreeNode node, transPtr *data, short *fpMap, short *fpMap2, int *isChoose, int *profit, int itemAdd, int itemRemove)
{
	
	//int itemNo;

	childLink nextChild;
	
	if (node == NULL)
	{
		return;
	}


	if (node->children == NULL)
	{
		// this node has no children
		// (i.e. this node is leaf)
		
		
		//doCreateFP(double *returnValue, int *freqItemP, int *indexList, FPTreeNode node, short *fpMap, int *isChoose, int *profit)
		doCreateFP_diff(returnValue, returnValue2, freqItemP, indexList, node, fpMap, fpMap2, isChoose, profit, itemAdd, itemRemove);
	}
	else
	{
		// this node has children
		// (need to explore the children first
		//  by using depth-first search)

		// explore children
		nextChild = node->children;
		while (nextChild != NULL)
		{
			//fp_scanTrans(double *returnValue, int *freqItemP, int *indexList, FPTreeNode node, transPtr *data, short *fpMap, int *isChoose, int *profit)
			fp_scanTrans_diff(returnValue, returnValue2, freqItemP, indexList, nextChild->node, data, fpMap, fpMap2, isChoose, profit, itemAdd, itemRemove);
			
			nextChild = nextChild->next;
		}

		if (node->parent == NULL)
		{
			// root
			return;
		}
		else
		{
			doCreateFP_diff(returnValue, returnValue2, freqItemP, indexList, node, fpMap, fpMap2, isChoose, profit, itemAdd, itemRemove);
		}
	}

}


/******************************************************************************************
 * Function: buildTree()
 *
 * Description:
 *	Build the initial FP-tree.
 *
 * Invoked from:	
 *	main()
 *
 * Functions to be invoked:
 *	insert_tree()
 *	q_sortA()
 *
 * Global variables:
 *	root		-> Pointer to the root of this initial FP-tree
 *	headerTableLink	-> Header table for this initial FP-tree
 *
 * Global variables (read only):
 *	numLarge[]	-> Large k-itemsets resulting list for k = 1 to realK
 */
double vm_buildTreeSet(transPtr *data, short *fpMap, int *isChoose, int *profit, double *revNo, int *chooseFlag)
{
 double returnValue = 0;
 int *freqItemP;	/* Store frequent items of a transaction */
 int *indexList;	/* indexList[i] = the index position in the large 1-item list storing freqItemP[i] */
 //int count;		/* Number of frequent items in a transaction */
 //FILE *fp;		/* Pointer to the database file */
 //int transSize;		/* Transaction size */
 //int item;		/* An item in the transaction */
 int i, j;//, m;
 //int path;		/* Number of new tree paths (i.e. new leaf nodes) created so far */

 //int itemNo;
 //int flag;


 returnValue = 0;

 /* Create header table */
 headerTableLinkSet = (FPTreeNode *) malloc (sizeof(FPTreeNode) * numLarge[0]);
 if (headerTableLinkSet == NULL) {
	printf("out of memory\n");
	exit(1);
 }
 for (i=0; i < numLarge[0]; i++)
	headerTableLinkSet[i] = NULL;
	
 /* Create root of the FP-tree */
 rootSet = (FPTreeNode) malloc (sizeof(FPNode));
 if (rootSet == NULL) {
	printf("out of memory\n");
	exit(1);
 }

 /* Initialize the root node */
 rootSet->numPath = 1;
 rootSet->parent = NULL;
 rootSet->children = NULL;
 rootSet->hlink = NULL;

 /* Create freqItemP to store frequent items of a transaction */
 freqItemP = (int *) malloc (sizeof(int) * numItem);
 if (freqItemP == NULL) {
	printf("out of memory\n");
	exit(1);
 }	

 indexList = (int *) malloc (sizeof(int) * numItem);
 if (indexList == NULL) {
	printf("out of memory\n");
	exit(1);
 }	


#ifdef FP_SCAN
 //find_no(root);
 //scanf("%d", &flag);
	fp_copyCount(root);
	//void fp_scanTrans(double *returnValue, int *freqItemP, int *indexList, FPTreeNode node, transPtr *data, short *fpMap, int *isChoose, int *profit)
	fp_vm_scanTrans(&returnValue, freqItemP, indexList, root, data, fpMap, isChoose, profit);
#else

	for (i = 0; i < noOfTrans; i++)
	{
		fp_doTransaction(&returnValue, data[i], freqItemP, indexList, rootSet, headerTableLinkSet, fpMap, isChoose, profit, 1);
	}
#endif

	// calculate the benefit of items in FP-tree
	//vm_getBenefitFP(&returnValue, rootSet, isChoose, profit, revNo);
	

 /* scan DB and insert frequent items into the FP-tree */
/* if ((fp = fopen(dataFile, "r")) == NULL) {
        printf("Can't open data file, %s.\n", dataFile);
        exit(1);
 }


 for (i=0; i < numTrans; i++) {

	//* Read the transaction size 
	fscanf(fp, "%d", &transSize);

	count = 0;
 	path = 0;

	for (j=0; j < transSize; j++) {

		//* Read a transaction item 
		fscanf(fp, "%d", &item);

		//* Store the item to the frequent list, freqItemP, 
		//* if it is a large 1-item.
		// 
		for (m=0; m < numLarge[0]; m++) {
			if (item == largeItem1[m]) {
				// Store the item 
				freqItemP[count] = item;
				// Store the position in the large 1-itemset list storing this item 
				indexList[count] = m;
				count++;
				break;
			} 
		}
	}

	//* Sort the items in the frequent item list in ascending order of indexList,
	// * i.e. sort according to the order of the large 1-itemset list
	// 
	q_sortA(indexList, freqItemP, 0, count-1, count);

	// Insert the frequent patterns of this transaction to the FP-tree. 
	insert_tree(&(freqItemP[0]), &(indexList[0]), 1, 0, count, rootSet, headerTableLinkSet, &path);
 } 
 fclose(fp);
*/


 free(freqItemP);
 free(indexList);
 //free(largeItem1);
 //free(support1);
 free_fpSet();

 return returnValue;
}




/******************************************************************************************
 * Function: buildTree()
 *
 * Description:
 *	Build the initial FP-tree.
 *
 * Invoked from:	
 *	main()
 *
 * Functions to be invoked:
 *	insert_tree()
 *	q_sortA()
 *
 * Global variables:
 *	root		-> Pointer to the root of this initial FP-tree
 *	headerTableLink	-> Header table for this initial FP-tree
 *
 * Global variables (read only):
 *	numLarge[]	-> Large k-itemsets resulting list for k = 1 to realK
 */
double vm_buildTreeSet_diff(transPtr *data, short *fpMap, short *fpMap2, int *isChoose, int *profit, double *revNo, int *chooseFlag, int itemAdd, int itemRemove)
{
 double returnValue = 0;
 double returnValue2 = 0;
 double returnValue3 = 0;
 int *freqItemP;	/* Store frequent items of a transaction */
 int *indexList;	/* indexList[i] = the index position in the large 1-item list storing freqItemP[i] */
 //int count;		/* Number of frequent items in a transaction */
 //FILE *fp;		/* Pointer to the database file */
 //int transSize;		/* Transaction size */
 //int item;		/* An item in the transaction */
 int i, j;//, m;
 //int path;		/* Number of new tree paths (i.e. new leaf nodes) created so far */

 //int itemNo;
 //int flag;

 int *isChoose2;


 returnValue = 0;

// for set1
 /* Create header table */
 headerTableLinkSet = (FPTreeNode *) malloc (sizeof(FPTreeNode) * numLarge[0]);
 if (headerTableLinkSet == NULL) {
	printf("out of memory\n");
	exit(1);
 }
 for (i=0; i < numLarge[0]; i++)
	headerTableLinkSet[i] = NULL;
	
 /* Create root of the FP-tree */
 rootSet = (FPTreeNode) malloc (sizeof(FPNode));
 if (rootSet == NULL) {
	printf("out of memory\n");
	exit(1);
 }

 /* Initialize the root node */
 rootSet->numPath = 1;
 rootSet->parent = NULL;
 rootSet->children = NULL;
 rootSet->hlink = NULL;



// for set2
 /* Create header table */
 headerTableLinkSet2 = (FPTreeNode *) malloc (sizeof(FPTreeNode) * numLarge[0]);
 if (headerTableLinkSet2 == NULL) {
	printf("out of memory\n");
	exit(1);
 }
 for (i=0; i < numLarge[0]; i++)
	headerTableLinkSet2[i] = NULL;
	
 /* Create root of the FP-tree */
 rootSet2 = (FPTreeNode) malloc (sizeof(FPNode));
 if (rootSet2 == NULL) {
	printf("out of memory\n");
	exit(1);
 }

 /* Initialize the root node */
 rootSet2->numPath = 1;
 rootSet2->parent = NULL;
 rootSet2->children = NULL;
 rootSet2->hlink = NULL;




 /* Create freqItemP to store frequent items of a transaction */
 freqItemP = (int *) malloc (sizeof(int) * numItem);
 if (freqItemP == NULL) {
	printf("out of memory\n");
	exit(1);
 }	

 indexList = (int *) malloc (sizeof(int) * numItem);
 if (indexList == NULL) {
	printf("out of memory\n");
	exit(1);
 }	


#ifdef FP_SCAN
 //find_no(root);
 //scanf("%d", &flag);
	fp_copyCount(root);
	//void fp_scanTrans(double *returnValue, int *freqItemP, int *indexList, FPTreeNode node, transPtr *data, short *fpMap, int *isChoose, int *profit)
	fp_scanTrans_diff(&returnValue, &returnValue2, freqItemP, indexList, root, data, fpMap, fpMap2, isChoose, profit, itemAdd, itemRemove);
#else

	for (i = 0; i < noOfTrans; i++)
	{
		printf("Problem!!!!.....\n"); //problem:need to calculate returnValue2
		fp_doTransaction(&returnValue, data[i], freqItemP, indexList, rootSet, headerTableLinkSet, fpMap, isChoose2, profit, 1);
	}
#endif

	// calculate the benefit of items in FP-tree

	isChoose2 = (int *) malloc(sizeof(int)*noOfItem);
	memcpy(isChoose2, isChoose, sizeof(int)*noOfItem);

	// for S U itemAdd
	isChoose2[itemAdd] = 1;
	isChoose2[itemRemove] = 0;
	getBenefitFP(&returnValue, rootSet, isChoose2, profit, revNo);

	// for S U itemRemove
	isChoose2[itemAdd] = 0;
	isChoose2[itemRemove] = 1;
	getBenefitFP(&returnValue2, rootSet2, isChoose2, profit, revNo);

	

 /* scan DB and insert frequent items into the FP-tree */
/* if ((fp = fopen(dataFile, "r")) == NULL) {
        printf("Can't open data file, %s.\n", dataFile);
        exit(1);
 }


 for (i=0; i < numTrans; i++) {

	//* Read the transaction size 
	fscanf(fp, "%d", &transSize);

	count = 0;
 	path = 0;

	for (j=0; j < transSize; j++) {

		//* Read a transaction item 
		fscanf(fp, "%d", &item);

		//* Store the item to the frequent list, freqItemP, 
		//* if it is a large 1-item.
		// 
		for (m=0; m < numLarge[0]; m++) {
			if (item == largeItem1[m]) {
				// Store the item 
				freqItemP[count] = item;
				// Store the position in the large 1-itemset list storing this item 
				indexList[count] = m;
				count++;
				break;
			} 
		}
	}

	//* Sort the items in the frequent item list in ascending order of indexList,
	// * i.e. sort according to the order of the large 1-itemset list
	// 
	q_sortA(indexList, freqItemP, 0, count-1, count);

	// Insert the frequent patterns of this transaction to the FP-tree. 
	insert_tree(&(freqItemP[0]), &(indexList[0]), 1, 0, count, rootSet, headerTableLinkSet, &path);
 } 
 fclose(fp);
*/



 free(isChoose2);
 free(freqItemP);
 free(indexList);
 //free(largeItem1);
 //free(support1);
 free_fpSet();
 free_fpSet2();

 returnValue3 = returnValue - returnValue2;
 return returnValue3;
}




void vm_getBenefitFP(double *returnValue, FPTreeNode node, int *isChoose, int *profit, double *revNo)
{
	int itemNo;

	int countNo;

	childLink nextChild;

	if (node->children == NULL)
	{
		// this node has no children
		// (i.e. this node is leaf)


		// check whether this item is selected
		itemNo = node->item;
		if ((node->parent != NULL) && (isChoose[itemNo] == 1))
		{
			countNo = node->count;
			if (countNo == 1)
			{
				(*returnValue) += profit[itemNo]*(1-countNo*revNo[itemNo]);
			}
			else
			{
				(*returnValue) += profit[itemNo]*(1-countNo*revNo[itemNo])*countNo;
			}
		}
	}
	else
	{
		// this node has children
		// (need to explore the children first
		//  by using depth-first seearch)

		// explore children
		nextChild = node->children;
		while (nextChild != NULL)
		{
			getBenefitFP(returnValue, nextChild->node, isChoose, profit, revNo);

			nextChild = nextChild->next;
		}

		//void getBenefitFP(double *returnValue, FPTreeNode node, int *isChoose, int *profit, double *revNo)

		// explore parent
		// check whether this item is selected
		itemNo = node->item;
		if ((node->parent != NULL) && (isChoose[itemNo] == 1))
		{
			countNo = node->count;
			if (countNo == 1)
			{
				(*returnValue) += profit[itemNo]*(1-countNo*revNo[itemNo]);
			}
			else
			{
				(*returnValue) += profit[itemNo]*(1-countNo*revNo[itemNo])*countNo;
			}
		}
	}
}


void vm_getBenefitFP2(double *returnValue, double *returnValue2, FPTreeNode node, int *isChoose, int *profit, double *revNo, int itemSpecial)
{
	int itemNo;

	int countNo;

	childLink nextChild;

	double temp;

	if (node->children == NULL)
	{
		// this node has no children
		// (i.e. this node is leaf)


		// check whether this item is selected
		itemNo = node->item;
		if ((node->parent != NULL) && (isChoose[itemNo] == 1))
		{
			countNo = node->count;
			temp = 0;
			if (countNo == 1)
			{
				temp += profit[itemNo]*(1-countNo*revNo[itemNo]);
			}
			else
			{
				temp += profit[itemNo]*(1-countNo*revNo[itemNo])*countNo;
			}
			(*returnValue) += temp;

			if (itemNo != itemSpecial)
			{
				(*returnValue2) += temp;
			}
		}
	}
	else
	{
		// this node has children
		// (need to explore the children first
		//  by using depth-first seearch)

		// explore children
		nextChild = node->children;
		while (nextChild != NULL)
		{
			//void getBenefitFP2(double *returnValue, double *returnValue2, FPTreeNode node, int *isChoose, int *profit, double *revNo, int itemSpecial)
			getBenefitFP2(returnValue, returnValue2, nextChild->node, isChoose, profit, revNo, itemSpecial);

			nextChild = nextChild->next;
		}

		//void getBenefitFP(double *returnValue, FPTreeNode node, int *isChoose, int *profit, double *revNo)

		// explore parent
		// check whether this item is selected
		itemNo = node->item;
		if ((node->parent != NULL) && (isChoose[itemNo] == 1))
		{
			countNo = node->count;
			temp = 0;
			if (countNo == 1)
			{
				temp += profit[itemNo]*(1-countNo*revNo[itemNo]);
			}
			else
			{
				temp += profit[itemNo]*(1-countNo*revNo[itemNo])*countNo;
			}

			(*returnValue) += temp;

			if (itemNo != itemSpecial)
			{
				(*returnValue2) += temp;
			}
		} 
	}
}




