

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "isvm.h"




extern int noOfItem;// = 7;
extern int noOfTrans;// = 12;

extern int *longArray;


void insert2Vert(vertPtr dataVert, int itemNo, int transNo)
{
	int *tempArray;

	int no;

	int i;

	int *noOfEltArray;
	int **tidArray;

	noOfEltArray = dataVert->noOfElt;
	tidArray = dataVert->tid;

	if (noOfEltArray[itemNo] == 0)
	{
		tidArray[itemNo] = (int *) malloc(sizeof(int));
		tidArray[itemNo][0] = transNo;

		noOfEltArray[itemNo] = 1;
	}
	else
	{
		tempArray = tidArray[itemNo];

		no = noOfEltArray[itemNo];
		tidArray[itemNo] = (int *) malloc(sizeof(int)*(no+1));

		// copy
		for (i = 0; i < no; i++)
		{
			tidArray[itemNo][i] = tempArray[i];
		}

		tidArray[itemNo][no] = transNo;

		free(tempArray);

		noOfEltArray[itemNo] = no+1;
	}
}

void freeList(nodePtr list)
{
	nodePtr tempNode;

	tempNode = list->next;

	if (tempNode != NULL)
	{
		freeList(tempNode);
	}
	
	free(list);
}

nodePtr vm_getDen(vertPtr dataVert, int *sel, int noOfSel, int itemJ, int *den)
{

	int *index;

	int min;
	int MAX = noOfTrans;

	int i;

	int itemNo;

	int temp;
	int minIndex;

	nodePtr list;
	nodePtr currNode;
	nodePtr tempNode;

	int aIndex = 0;

	int *noOfEltArray;
	int **tidArray;

	int pointing;

	noOfEltArray = dataVert->noOfElt;
	tidArray = dataVert->tid;

	(*den) = 0;

	index = (int *) malloc(sizeof(int)*noOfSel);
	memset(index, 0, sizeof(int)*noOfSel);


	// initialize the min
	// find the min
	min = MAX;
	minIndex = 0;
	for (i = 0; i < noOfSel; i++)
	{
		itemNo = sel[i];

		if (noOfEltArray[itemNo] > 0)
		{
			temp = tidArray[itemNo][0];

			if (temp < min)
			{
				min = temp;
				minIndex = i;
				//index[i]++;
				//break;
			}
		}
	}

	

	// cannot find the min
	if (min == MAX)
	{
		free(index);
		
		return NULL;
	}

	index[minIndex]++;
	

	
#ifdef ARRAY
	longArray[(*den)] = min;
#else
	//
	list = (nodePtr) malloc(sizeof(node));
	list->elt = min;
	list->next = NULL;

	currNode = list;	
#endif
	(*den)++;

	while (1)
	{
		// find the min
		min = MAX;
		for (i = 0; i < noOfSel; i++)
		{
			itemNo = sel[i];

			pointing = index[i];

			// check whether this tid is checked completely
			if (pointing < noOfEltArray[itemNo])
			{
				temp = tidArray[itemNo][pointing];

				if (temp < min)
				{
					min = temp;
					aIndex = i;
				}
			}
		}

		if (min == MAX)
		{
			// that menas all tids are checked completely
			break;
		}
		else
		{
			index[aIndex]++;

			// check whether min is equal to currNode
#ifdef ARRAY
			if (min == longArray[(*den)-1])
#else
			if (min == currNode->elt)
#endif
			{
				// do nothing
			}
			else
			{
				// we need to add the min to the list
#ifdef ARRAY
				longArray[(*den)] = min;
				(*den)++;
#else
				tempNode = (nodePtr) malloc(sizeof(node));
				tempNode->elt = min;
				tempNode->next = NULL;

				(*den)++;

				currNode->next = tempNode;
				currNode = tempNode;
#endif
			}
		}
		
	}

	// here, a list is created 

	free(index);

	//currNode = list;
	//printf("The list is : ");
	//while (currNode != NULL)
	//{
	//	printf("%d ", currNode->elt);
	//	currNode = currNode->next;
	//}
	//printf("\n");


	return list;

}

void vm_getNum(vertPtr dataVert, int *sel, int noOfSel, int itemJ, nodePtr list, int den, int *num)
{
	int ptrList;
	int ptrItemJ;
	int ptrLongArray;

	nodePtr currNode;
	//nodePtr tempNode;

	int eltList;
	int eltItemJ;
	int maxValue;

	int flag;

	int *noOfEltArray;
	int **tidArray;

	noOfEltArray = dataVert->noOfElt;
	tidArray = dataVert->tid;

	(*num) = 0;

	ptrList = 0;
	ptrItemJ = 0;
	ptrLongArray = 0;


#ifdef ARRAY
	
#else
	currNode = list;
#endif

	if (den <= 0)
	{
		//(*result) = 0;
		(*num) = 0;

		//free(index);
		//freeList(list);
		return;
	}
#ifdef ARRAY
	eltList = longArray[ptrLongArray];
#else
	eltList = currNode->elt;
#endif
	if (noOfEltArray[itemJ] <= 0)
	{
		//(*result) = 0;
		(*num) = 0;

		//free(index);
		//freeList(list);
		return;
	}
	eltItemJ = tidArray[itemJ][ptrItemJ];

	// find max;
	if (eltList < eltItemJ)
	{
		maxValue = eltItemJ;
		flag = 0;
	}
	else
	{
		maxValue = eltList;
		flag = 1;
	}

	while (1)
	{
		if (flag == 0)
		{
			// skip for the list
#ifdef ARRAY
			while ((ptrLongArray < den) && (longArray[ptrLongArray] < maxValue))
			{
				ptrLongArray++;
			}

			if (ptrLongArray >=den)
			{
				// no more same elt
				break;
			}
			else if (longArray[ptrLongArray] == maxValue)
			{
				(*num)++;
			}
#else
			while ((currNode != NULL) && (currNode->elt < maxValue))
			{
				currNode = currNode->next;
			}

			if (currNode == NULL)
			{
				// no more same elt
				break;
			}
			else if (currNode->elt == maxValue)
			{
				(*num)++;
			}
#endif
			ptrItemJ++;
			if (ptrItemJ >= noOfEltArray[itemJ])
			{
				break;
			}
			eltItemJ = tidArray[itemJ][ptrItemJ];
		}
		else
		{
			// skip for the itemJ
			while ((ptrItemJ < noOfEltArray[itemJ]) && (tidArray[itemJ][ptrItemJ] < maxValue))
			{
				ptrItemJ++;
			}

			if (ptrItemJ >= noOfEltArray[itemJ])
			{
				// no more same elt
				break;
			}
			else if (tidArray[itemJ][ptrItemJ] == maxValue)
			{
				(*num)++;
			}

#ifdef ARRAY
			ptrLongArray++;
			if (ptrLongArray >= den)
			{
				break;
			}
			eltList = longArray[ptrLongArray];
#else
			currNode = currNode->next;
			if (currNode == NULL)
			{
				break;
			}
			eltList = currNode->elt;
#endif
		}

		// find the maxValue
		if (eltList < eltItemJ)
		{
			maxValue = eltItemJ;
			flag = 0;
		}
		else
		{
			maxValue = eltList;
			flag = 1;
		}
	}


}

void getCSFactor(vertPtr dataVert, int *sel, int noOfSel, int itemJ, double *result)
{
	int num = 0;
	int den = 0;

	//int *index;

	nodePtr list;

	list = vm_getDen(dataVert, sel, noOfSel, itemJ, &den);
#ifdef ARRAY
	if (den == 0)
#else
	if (list == NULL)
#endif
	{
		(*result) = 0;
		return;
	}

	// check with itemJ
	vm_getNum(dataVert, sel, noOfSel, itemJ, list, den, &num);

	//free(index);
#ifdef ARRAY
#else
	freeList(list);
#endif
	//printf("  num : %d\n", num);
	//printf("  den : %d\n", den);

	(*result) = num/(double)den;

}


void getCSFactorSquare(vertPtr dataVert, int *sel, int noOfSel, int itemJ, double *result)
{
	int num = 0;
	int den = 0;

	//int *index;

	nodePtr list;

	list = vm_getDen(dataVert, sel, noOfSel, itemJ, &den);
#ifdef ARRAY
	if (den == 0)
#else
	if (list == NULL)
#endif
	{
		(*result) = 0;
		return;
	}

	// check with itemJ
	vm_getNum(dataVert, sel, noOfSel, itemJ, list, den, &num);

	//free(index);
#ifdef ARRAY
#else
	freeList(list);
#endif
	//printf("  num : %d\n", num);
	//printf("  den : %d\n", den);

	(*result) = num*num/(double)den;

}


vertPtr transform2Vert(transPtr *data)
{
	vertPtr returnValue;

	int no;

	int i, j;

	int itemNo;

	returnValue = (vertPtr) malloc(sizeof(vert));

	returnValue->noOfElt = (int *) malloc(sizeof(int)*noOfItem);
	returnValue->tid = (int **) malloc(sizeof(int)*noOfItem);
	memset(returnValue->noOfElt, 0, sizeof(int)*noOfItem);

	for (i = 0; i < noOfTrans; i++)
	{
		no = data[i]->noOfItem;
		for (j = 0; j < no; j++)
		{
			itemNo = data[i]->item[j];
			insert2Vert(returnValue, itemNo, i);
		}
	}
	return returnValue;
}


int main2()
{
	transPtr *data;
	vertPtr dataVert;

	int i, j;

	noOfItem = 10;

	data = (transPtr *) malloc(sizeof(transPtr)*noOfTrans);
	for (i = 0; i < noOfTrans; i++)
	{
		data[i] = (transPtr) malloc(sizeof(trans));

	}

	i = 0;
	data[i]->noOfItem = 2;
	data[i]->item = (int *) malloc(sizeof(int)*data[i]->noOfItem);
	data[i]->item[0] = 1;
	data[i]->item[1] = 6;

	i = 1;
	data[i]->noOfItem = 2;
	data[i]->item = (int *) malloc(sizeof(int)*data[i]->noOfItem);
	data[i]->item[0] = 2;
	data[i]->item[1] = 5;

	i = 2;
	data[i]->noOfItem = 2;
	data[i]->item = (int *) malloc(sizeof(int)*data[i]->noOfItem);
	data[i]->item[0] = 1;
	data[i]->item[1] = 6;

	i = 3;
	data[i]->noOfItem = 3;
	data[i]->item = (int *) malloc(sizeof(int)*data[i]->noOfItem);
	data[i]->item[0] = 2;
	data[i]->item[1] = 4;
	data[i]->item[2] = 6;

	// transform (put at the beginning)
	dataVert = transform2Vert(data);

	// print the DB vertically
	printf("DB Vertical :\n");
	for (i = 0; i < noOfItem; i++)
	{
		printf(" item %d: ", i);
		for (j = 0; j < dataVert->noOfElt[i]; j++)
		{
			printf("%d ", dataVert->tid[i][j]);
		}
		printf("\n");
	}
}

int main9()
{
	vertPtr dataVert;

	double result;

	int *sel;
	int noOfSel;
	int itemJ;

	int i, j;

	noOfItem = 6;

	noOfTrans = 100;
	longArray = (int *) malloc(sizeof(int)*noOfTrans);

	dataVert = (vertPtr) malloc(sizeof(vert));

	dataVert->noOfElt = (int *) malloc(sizeof(int)*noOfItem);
	dataVert->tid = (int **) malloc(sizeof(int)*noOfItem);
	memset(dataVert->noOfElt, 0, sizeof(int)*noOfItem);


	insert2Vert(dataVert, 0, 1);
	insert2Vert(dataVert, 0, 2);

	insert2Vert(dataVert, 1, 3);
	insert2Vert(dataVert, 1, 7);
	insert2Vert(dataVert, 1, 10);

	insert2Vert(dataVert, 2, 1);
	insert2Vert(dataVert, 2, 5);
	insert2Vert(dataVert, 2, 7);
	
	insert2Vert(dataVert, 3, 0);
	insert2Vert(dataVert, 3, 1);
	insert2Vert(dataVert, 3, 7);
	insert2Vert(dataVert, 3, 10);

	insert2Vert(dataVert, 4, 0);
	insert2Vert(dataVert, 4, 2);
	insert2Vert(dataVert, 4, 3);
	insert2Vert(dataVert, 4, 4);

	printf("DB Vertical :\n");
	for (i = 0; i < noOfItem; i++)
	{
		printf(" item %d: ", i);
		for (j = 0; j < dataVert->noOfElt[i]; j++)
		{
			printf("%d ", dataVert->tid[i][j]);
		}
		printf("\n");
	}

	printf("hello !\n");

	itemJ = 4;
	noOfSel = 3;

	sel = (int *) malloc(sizeof(int)*noOfSel);
	sel[0] = 0;
	sel[1] = 1;
	sel[2] = 2;


	printf("Sel : ");
	for (i = 0; i < noOfSel; i++)
	{
		printf("%d ", sel[i]);
	}
	printf("\n");

	printf("itemJ : %d\n", itemJ);

	// get the csfactor
	getCSFactor(dataVert, sel, noOfSel, itemJ, &result);

	printf("Result : %.2f\n", result);

	return 0;
}

